Graphics3D 1024,768,32,1

SetBuffer BackBuffer()

Global SW%=GraphicsWidth()
Global SH%=GraphicsHeight()

Const startflakes%=0   ; start amount of flakes
Const totalflakes%=50000   ; maximum amount of flakes
Const snowchance#=50      ; chance in % for new flakes
Const chanceflakes#=100    ; randomize amount of new flakes (1...x)
Const chancestick#=0.8     ; change that a flake sticks to the matte (here: 80%)

Type snow
	
	Field x#,y#
	Field col%
	Field dirx#,diry#
	Field depth%
	
End Type

CreateSnow(startflakes)

logo=LoadImage("imageB3D.jpg") : Global lbuffer=ImageBuffer(logo)
matte=LoadImage("matteB3D.png") : Global mbuffer=ImageBuffer(matte)

Dim SNOW%(SW,SH)
LockBuffer mbuffer
For y=0 To SH-1
	For x=0 To SW-1
		r=(ReadPixelFast(x,y,mbuffer) And $ff0000)/$10000
		SNOW(x,y)=0
		If r>192 Then SNOW(x,y)=1
	Next
Next
UnlockBuffer mbuffer

buffer=BackBuffer()

timer=CreateTimer(60)

music=LoadSound("Frozen Silence-Silent night (piano).ogg")

LoopSound music

PlaySound music

While Not KeyHit(1)
	
	DrawImage logo,0,0
	
	LockBuffer buffer
	
	AppTitle UpdateSnow(buffer)+" Flakes"
	
	UnlockBuffer buffer
	
	Flip 0
	
	WaitTimer timer
	
Wend

End

Function UpdateSnow(buffer%)
	
	Local counter%=0
	
	LockBuffer buffer
	
	For s.snow = Each snow
		
		recycle=False
		
		counter=counter+1
		
		s\x=s\x+s\dirx
		s\y=s\y+s\diry
		
        If s\y>SH-1 Then RecycleFlake(s)
		If s\y<0 Then RecycleFlake(s)
		
        If s\y>=0 And s\x>=0 And s\x<SW And s\y<SH Then
			
			fx=Int(s\x)
			fy=Int(s\y)
			
			dist%=Rand(-1,1)
			
			If fx<dist Then fx=(SW-dist)+fx
			If fx>(SW-dist) Then fx=fx-(SW-dist-1)
			
			If SNOW(fx,fy)<>0 And Rnd(1)>chancestick Then
				
				fx=fx+(SNOW(fx-dist,fy+1)-SNOW(fx+dist,fy+1))
				
				If fx<dist Then fx=(SW-dist)+fx
				If fx>(SW-dist) Then fx=fx-(SW-dist-1)
				
				If fy<1 Then fy=1
				If fy>SH-2 Then fy=SH-2
				
				If SNOW(fx,fy)<>0 Then
					
					SNOW(fx,fy-1)=(SNOW(fx-dist,fy)+SNOW(fx+dist,fy)+SNOW(fx,fy-1)+SNOW(fx,fy+1))*Rnd(0.1,0.25)
					
					RecycleFlake(s)
					
					If fx>0 And fx<SW-1 And fy>0 And fy<SH-1 Then
						
						LockBuffer lbuffer
						rgb=s\col*$10000+s\col*$100+s\col
						WritePixelFast fx,fy,rgb,lbuffer
						
						If Rnd(1)>0.75 Then
							
							WritePixelFast fx-1,fy,rgb,lbuffer
							WritePixelFast fx,fy+1,rgb,lbuffer
							
							
						EndIf
						
						If Rnd(1)>0.75 Then
							
							WritePixelFast fx+1,fy,rgb,lbuffer
							WritePixelFast fx,fy-1,rgb,lbuffer
							
						EndIf
						
						UnlockBuffer lbuffer
						
					EndIf
					
				EndIf
				
			EndIf
			
		EndIf
		
        rgb=s\col*$10000+s\col*$100+s\col
		
		If s\y>1 And s\y<SH-2 And s\x>1 And s\x<SW-2 Then
			
			WritePixelFast Int(s\x),Int(s\y),rgb,buffer
			
			If Rnd(1)>0.75 Then
				
				WritePixelFast Int(s\x-1),Int(s\y),rgb,buffer
				WritePixelFast Int(s\x),Int(s\y+1),rgb,buffer
				
				
			EndIf
			
			If Rnd(1)>0.75 Then
				
				WritePixelFast Int(s\x+1),Int(s\y),rgb,buffer
				WritePixelFast Int(s\x),Int(s\y-1),rgb,buffer
				
			EndIf
			
		EndIf
		
	Next
	
    c=Rand(1,chanceflakes)
	If counter+c<=totalflakes And Rnd(1)>(1-(snowchance/100.0)) Then
		For i=1 To c
			CreateNewFlake()
		Next
	EndIf
	
	UnlockBuffer buffer
	
	Return counter
	
End Function

Function RecycleFlake(s.snow)
	
	s\x=Rnd(0,SW-1)
	s\y=Rnd(-SH,-1)
	s\col=Rand(224,255)
	s\dirx=Rnd(-1,1)
	s\diry=Rnd(0.5,2)
	
End Function

Function CreateSnow(flakes%=1)
	
	Local i%
	
	For i=1 To flakes
		
		CreateNewFlake()
		
	Next
	
End Function

Function CreateNewFlake()
	
	s.snow = New snow
	s\x=Rnd(0,SW-1)
	s\y=Rnd(-SH,0)
	s\col=Rand(224,255)
	s\dirx=Rnd(-1,1)
	s\diry=Rnd(0.5,1)
	
End Function
;~IDEal Editor Parameters:
;~C#Blitz3D