' Let it snow by Krischan
' -----------------------
'
' Image taken from www.bunnybua.com, redesigned for this demo
' Music taken from www.jamendo.com/en/track/442222, converted to OGG

SuperStrict

Graphics 1024,768,32,60

Global SW:Int=GraphicsWidth()
Global SH:Int=GraphicsHeight()

Global SNOW:Int[SW+1,SH+1]
Global s:snowflake

Const startflakes:Int		= 0		' start amount of flakes
Const totalflakes:Int		= 20000	' maximum amount of flakes
Const snowchance:Float		= 50		' chance in % For New flakes
Const chanceflakes:Float	= 100		' randomize amount of New flakes (1...x)
Const chancestick:Float	= 0.8		' change that a flake sticks To the matte (here: 80%)

Type snowflake

	Global List:TList = CreateList()
	
	Method New()
		ListAddLast(List, Self)
	End Method
	
	Field x:Float,y:Float
	Field col:Int
	Field dirx:Float,diry:Float
	Field style:Float
	Field sinus:Float
	
End Type

Global logo:TPixmap=LoadPixmap("imageBMX.jpg")
Global matte:TPixmap=LoadPixmap("matteBMX.png")
Global flake:TImage=LoadImage("snow.png")

For Local y:Int=0 To SH-1

	For Local x:Int=0 To SW-1
	
		Local rgb:Int=ReadPixel(matte,x,y)
		Local r:Int=(rgb & $ff0000) / $10000
		
		SNOW[x,y]=0
		
		If r>192 Then SNOW[x,y]=1
	Next
	
Next

Global music:TSound = LoadSound("Frozen Silence-Silent night (piano).ogg", True)
PlaySound music

CreateSnow(startflakes)

SetBlend ALPHABLEND

While Not KeyHit(KEY_ESCAPE)

	Cls

	DrawPixmap logo,0,0
		
	UpdateSnow(s)
	
	Flip 0
	
Wend

EndGraphics()

End

Function RecycleFlake(s:snowflake)
	
	s.x=Rnd(0,SW-1)
	s.y=Rnd(-SH,-1)
	s.col=Rand(224,255)
	s.dirx=Rnd(-1,1)
	s.diry=Rnd(0.5,2)
	s.style=Rand(0,3)
	s.sinus=Rnd(360)
	
End Function

Function CreateSnow(flakes:Int=1)
		
	For Local i:Int=1 To flakes
		
		CreateNewFlake()
		
	Next
	
End Function

Function CreateNewFlake()
	
	Local s:snowflake = New snowflake
	
	RecycleFlake(s)
		
End Function

Function UpdateSnow:Int(s:snowflake)
	
	Local counter:Int=0
	Local rgb:Int
	Local recycle:Int
	Local dist:Int
	Local fx:Int,fy:Int
	Local c:Int,i:Int
		
	For s:snowflake = EachIn snowflake.List
		
		recycle=False
		
		counter=counter+1
		
		s.sinus=s.sinus+Rnd(3) Mod 360
		
		s.x=s.x+s.dirx+(Sin(s.sinus)*0.5)
		s.y=s.y+s.diry
		
        	If s.y>SH-1 Then RecycleFlake(s)
		If s.y<0 Then RecycleFlake(s)
		
        	If s.y>=0 And s.x>=0 And s.x<SW And s.y<SH Then
			
			fx=Int(s.x)
			fy=Int(s.y)
			
			dist=Rand(-1,1)
			
			If fx<dist Then fx=(SW-dist)+fx
			If fx>(SW-dist) Then fx=fx-(SW-dist-1)
			
			If fx<1 Then fx=1
			If fx>SW-2 Then fx=SW-2
			If fy<1 Then fy=1
			If fy>SH-2 Then fy=SH-2
				
			If SNOW[fx,fy]<>0 And Rnd(1)>chancestick Then
				
				If fx<dist Then fx=(SW-dist)+fx
				If fx>(SW-dist) Then fx=fx-(SW-dist-1)
				
				If fx<1 Then fx=1
				If fx>SW-2 Then fx=SW-2
				If fy<1 Then fy=1
				If fy>SH-2 Then fy=SH-2
				
				If SNOW[fx,fy]<>0 Then
									
					RecycleFlake(s)
					
					If fy-1>0 Then SNOW[fx,fy-1]=1
					If fx-1>0 Then SNOW[fx-1,fy]=1
					If fx+1<SW-1 Then SNOW[fx+1,fy]=1
					
					If fx>0 And fx<SW-1 And fy>0 And fy<SH-1 Then
					
						rgb=toARGB(s.col,s.col,s.col,s.col)

						WritePixel(logo,fx,fy,rgb)
						
						If Rnd(1)>0.75 Then
						
							WritePixel(logo, fx-1,fy,rgb)
							WritePixel(logo, fx,fy+1,rgb)
														
						EndIf
						
						If Rnd(1)>0.75 Then
							
							WritePixel(logo, fx+1,fy,rgb)
							WritePixel(logo, fx,fy-1,rgb)
							
						EndIf
						
					EndIf
					
				EndIf
				
			EndIf
			
		EndIf
			
		If s.y>1 And s.y<SH-2 And s.x>1 And s.x<SW-2 Then
		
			DrawSubImageRect(flake,fx-1,fy-1,3,3,(s.style*3),0,3,3)
	
		EndIf
		
	Next
	
	c=Rand(1,chanceflakes)
	
	If counter+c<=totalflakes And Rnd(1)>(1-(snowchance/100.0)) Then
		For i=1 To c
			CreateNewFlake()
		Next
	EndIf
	
	Return counter
	
End Function

Function toARGB:Int(a:Int,r:Int,g:Int,b:Int)

	Return ((a Shl 24)|(r Shl 16)|(g Shl 8)|b)
	
End Function